//  _ ___ _______     ___ ___ ___  ___ _   _ ___ _____ ___ 
// / |_  )__ /   \   / __|_ _| _ \/ __| | | |_ _|_   _/ __| 
// | |/ / |_ \ |) | | (__ | ||   / (__| |_| || |  | | \__ \ 
// |_/___|___/___/   \___|___|_|_\\___|\___/|___| |_| |___/ 
// 
// Light Sensor Alarm Clock
// 
// Made by Corbin Newhard
// License: Public Domain
// Downloaded from: https://123d.circuits.io/circuits/1568222-light-sensor-alarm-clock

// TONES  ==========================================
// Start by defining the relationship between 
//       note, period, &  frequency. 
#define  c     3830    // 261 Hz 
#define  d     6428    // 156 Hz 
#define  D     3219    // 311 Hz
#define  e     3038    // 329 Hz 
#define  f     2864    // 349 Hz 
#define  g     2550    // 392 Hz 
#define  a     2272    // 440 Hz 
#define  b     2028    // 493 Hz 
#define  C     1912    // 523 Hz 
// Define a special note, 'R', to represent a rest
#define  R     0

// SETUP ============================================
// Set up speaker on a PWM pin (digital 9, 10 or 11)
int speakerOut = 11;

int led = 13;


void setup() { 
  pinMode(speakerOut, OUTPUT);
  
  pinMode(led, OUTPUT);


  Serial.begin (9600);
 
}

// MELODY and TIMING  =======================================
//  melody[] is an array of notes, accompanied by beats[], 
//  which sets each note's relative length (higher #, longer note) 
int melody[] = {  f,  f,  f,  f,  f, D, f, f,  D, f, D, f, f, d, d, R, f, f, d, d, R };
int beats[]  = { 8, 8, 8, 8, 16, 8, 16, 16, 8, 16, 24, 8, 8, 8, 8, 1, 8, 8, 8, 8, 1}; 
int MAX_COUNT = sizeof(melody) / 2; // Melody length, for looping.

// Set overall tempo
long tempo = 15000;
// Set length of pause between notes
int pause = 0;
// Loop variable to increase Rest length
int rest_count = 15; //<-BLETCHEROUS HACK; See NOTES

// Initialize core variables
int tone_ = 0;
int beat = 0;
long duration  = 0;

// PLAY TONE  ==============================================
// Pulse the speaker to play a tone for a particular duration
void playTone() {
  long elapsed_time = 0;
  if (tone_ > 0) { // if this isn't a Rest beat, while the tone has 
    //  played less long than 'duration', pulse speaker HIGH and LOW
    while (elapsed_time < duration) {

      digitalWrite(speakerOut,HIGH);
      delayMicroseconds(tone_ / 2);

      // DOWN
      digitalWrite(speakerOut, LOW);
      delayMicroseconds(tone_ / 2);

      // Keep track of how long we pulsed
      elapsed_time += (tone_);
    } 
  }
  else { // Rest beat; loop times delay
    for (int j = 0; j < rest_count; j++) { // See NOTE on rest_count
      delayMicroseconds(duration);  
    }                                
  }
}

void lightShow()
{
    
    digitalWrite(led, HIGH);   
    delay(60);
    
    digitalWrite(led, LOW);
    delay(60);
    

}

// LET THE WILD RUMPUS BEGIN =============================
void loop() {
 int sensorValue = analogRead(A0);

 Serial.println(sensorValue);


 if (sensorValue >= 20) //ADJUST THIS VALUE FOR DIFFERENT LIGHT VALUES
 {
  
  // Set up a counter to pull from melody[] and beats[]
  for (int i=0; i<MAX_COUNT; i++) {
    tone_ = melody[i];
    beat = beats[i];

    duration = beat * tempo; // Set up timing

    playTone();
    // A pause between notes...
    delayMicroseconds(pause);
    
    lightShow();
    
    

  }
}
}
